#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "tty.h"
#include "main.h"

int	CamReset(void);
int     CamOk(void);
int	CamStatus(int);
int	CamHowmany(void);
int	CamDeletepicture(int);

extern int Camfd;

void
CloseCamera()
{
    if (!(Getfd() < 0)){
	CamOk();
	CamStatus(0);
	CamReset();
	closetty(Getfd());
    }
}

int
InitCamera(char *devpath, int speed)
{
    Setfd(opentty(devpath, speed));

    if (Getfd() < 0)
	return -1;

    if (CamOk() < 0)
	return -1;
    
    return 0;
}

int
GetPicCount()
{
    return CamHowmany();
}

int
RemoveImage(int pos)
{
    Thumbnail *t = &thumbnails[pos];

    if(t->protect)
	return -1;

    if (CamDeletepicture(pos) < 0) {
	fprintf(stderr, "Delete picture %d failed\n", pos+1);
	return -1;
    }
    
#ifndef CLI
    if(t->thumbxim)
	XDestroyImage(t->thumbxim);
#endif
    if(t->thumb)
	free(t->thumb);
    
    memcpy(&thumbnails[pos], &thumbnails[pos+1], (totalpics-pos-1)*sizeof(Thumbnail));

    totalpics--;
    return 0;
}
